package cz.muni.fi.pb162.stackexample;


/**
 * This is a simple, example implementation of a stack that can store only integers. It supports only basic operations.
 * 
 * @author Rastislav Mirek
 * @version (a version number or a date)
 */
public class NumberStack implements IntegerStack
{
    private StackElement top;

    /**
     * Constructor for objects of class NumberStack
     * Inicializes stack
     */
    public NumberStack()
    {
        top = null;  //stack is initially empty 
    }
    
    public NumberStack(int bottom){
        this();
        push(bottom);
    }
    
    public NumberStack(int first, short second){
        this(first);
        push(second);
    }

    /**
     * Stores given integer value on the top of the stack
     * @param numberToStore integer value to store in the stack
     */
    public void push(int numberToStore){
        StackElement newTop = new StackElement(numberToStore, this.top);
        top = newTop;
    }
    
    public void push(int firstNumber, int secNumber){
        push(firstNumber);
        push(secNumber);
    }
    
    public void push(short numberToStore){
        push((int)numberToStore);
    }
    
    /**
     * Deletes the top-most value from the stack. The value below it becames the next top-most value
     * @return the top-most value of the stack that is to be removed or <code>null</code> if the stack is empty
     */
    public Integer pop(){
        if(isEmpty()){
            return null;  //if the stack is empty, return null 
        }
        
        int oldTopValue = top.getValue(); //else (if stack is not empty) store top value in local variable to be returned later, make second top-most element the top-most and return stored value
        top = top.getBelow();
        return oldTopValue;
    }
    
    /**
     * @return true if the stack is empty, false otherwise
     */
    public boolean isEmpty(){
        return top == null;   //stack is empty if the top atribut is set to null - there is no element in the stack
    }
}
