package cz.muni.fi.pb162.stackexample;


/**
 * This class represents a stack elememnt for NumberStack
 * 
 * @author Rastislav Mirek
 */
public class StackElement
{
    private int value;
    private StackElement below;
    
    /**
     * @param value Value that this <code>StackElement</code> holds.
     * @param below <code>StackElement that is below this element in the stack or <code>null</code> if this element is bottom-most in the stack
     */
    StackElement(int value, StackElement below){
        this.value = value;
        this.below = below;
    }
    
    /**
     * @return <code>StackElement</code> which is under this <code>StackElement</code> in stack or <code>null</code> if this StackElement is bottom-most in the stack.
     */
    StackElement getBelow(){
        return below;
    }
    
    /**
     * Used by stack's metod's when poping top-most element and replacing it by second top-most.
     * @return value which is stored in this StackElement
     */
    int getValue(){
        return value;
    }
}
